﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGridFieldChooserToggle
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new SampleData();
        }
    }

    public class SampleDataItem
    {
        public string name { get; set; }
        public string department { get; set; }
        public double salary { get; set; }
        public string email { get; set; }
    }

    public class SampleData : ObservableCollection<SampleDataItem>
    {
        public SampleData()
        {
            Add(new SampleDataItem { name = "Joe", department = "Sales", salary = 70000.0, email = "joe@email.com" });
            Add(new SampleDataItem { name = "Mary", department = "Engineering", salary = 71000.0, email = "mary@email.com" });
            Add(new SampleDataItem { name = "Jim", department = "Sales", salary = 72000.0, email = "jim@email.com" });
        }
    }

public class ToggleFieldVisibility : Behavior<LabelPresenter>
{
    private LabelPresenter Presenter { get { return this.AssociatedObject; } }

    protected override void OnAttached()
    {
        Presenter.PreviewMouseLeftButtonDown -= Presenter_PreviewMouseLeftButtonDown;
        Presenter.PreviewMouseLeftButtonDown += Presenter_PreviewMouseLeftButtonDown;
    }

    void Presenter_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
    {
        var fieldChooser = (FieldChooser)Infragistics.Windows.Utilities.GetAncestorFromType(Presenter, typeof(FieldChooser), false);
        fieldChooser.ExecuteCommand(FieldChooserCommands.ToggleVisibility, Presenter.Field);
        e.Handled = true;
    }
}
}
